.SH "HOSTRANGED SUPPORT"
The host input specified by the user can accept multiple hosts for
parallel out of band communication and output.  Multiple hosts can be
input either as an explicit comma seperated lists of hosts or a range
of hostnames in the general form: prefix[n-m,l-k,...], where n < m and
l < k, etc.  The later form should not be confused with regular
expression character classes (also denoted by []). For example,
foo[19] does not represent foo1 or foo9, but rather represents a
degenerate range: foo19.
.LP
This range syntax is meant only as a convenience on clusters with a
prefixNN naming convention and specification of ranges should not be
considered necessary -- the list foo1,foo9 could be specified as such,
or by the range foo[1,9].
.LP
Some examples of range usage follow:
.nf
    foo[01-05] instead of foo01,foo02,foo03,foo04,foo05
    foo[7,9-10] instead of foo7,foo9,foo10
    foo[0-3] instead of foo0,foo1,foo2,foo3
.fi
.LP
As a reminder to the reader, some shells will interpret brackets ([
and ]) for pattern matching.  Depending on your shell, it may be
necessary to enclose ranged lists within quotes.
.LP
By default, standard output from each node specified will be output
with the hostname prepended to each line.  Although this output is
readable in many situations, it may be difficult to read in other
situations. For example, output from multiple nodes may be mixed
together.  The \fB\-B\fR and \fB\-C\fR options can be used to change
this default.  
